#
# top500-fishing.R, 21 Apr 24
#
# Data from:
# Fortune 500 from Wayback machine

library("colorspace")
library("plyr")


par(bty="l")
par(las=1)
par(pch="+")
pal_col=rainbow(4)


company_rank=function(df)
{
df=df[order(df$year), ]
lines(df$year, 101-df$rank, col=df$col_str[1])
}



t500=read.csv("top500.csv", as.is=TRUE)
c500=read.csv("companies.csv", as.is=TRUE)

t500=merge(t500, c500)

# length(which(c500$is_computer == 1))
# [1] 95

gpt4_cc=subset(t500, is_computer == 1)

# Companies ranked <= 100 in any year
gpt4_cc_r100=subset(gpt4_cc, rank <=100)

# Companies that GPT-4 classified as computer companies.
# But I consider to be Non-computer companies ranked <= 100
not_CC=c("AT&T Technologies",
		"Cisco Systems",
		"Electronic Data Systems",
		"Ingram Micro",
		"ITT Industries",
		"Lucent Technologies",
		"Motorola",
		"Rockwell Automation",
		"Sprint Nextel",
		"Teledyne",
		"Verizon Communications",
		"Xerox")

cc=subset(gpt4_cc_r100, !(company %in% not_CC))

u_cc=unique(cc$company)
pal_col=rainbow(length(u_cc))

cc$col_str=mapvalues(cc$company, u_cc, pal_col)

plot(1, type="n",
	yaxt="n",
	xlim=c(1955, 2007), ylim=c(1, 100),
	xlab="Year", ylab="Rank")

y_rank=c(1, 25, 50, 75, 100)
axis(2, at=y_rank, label=rev(y_rank))


d_ply(cc, .(company), company_rank)

legend("topleft", legend=u_cc,
                        fill=pal_col, border="white", bty="n")

dev.copy(dev=png, file="revenue-rank-computer-comp.png")
dev.off()

